/*
    addcontactwizard.h - Kopete's Add Contact Wizard

    Copyright (c) 2003 by Will Stephenson        <will@stevello.free-online.co.uk>
    Copyright (c) 2002 by Nick Betcher           <nbetcher@kde.org>
    Copyright (c) 2002 by Duncan Mac-Vicar Prett <duncan@kde.org>

    Kopete    (c) 2002-2004 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef ADDCONTACTWIZARD_H
#define ADDCONTACTWIZARD_H

#include <tqptrlist.h>
#include <tqvaluelist.h>
#include <tqmap.h>

#include <kdebug.h>
#include <tdeabc/addressbook.h>
#include "addcontactwizard_base.h"

class AddContactPage;
class TQCheckListItem;

namespace Kopete
{
class Protocol;
class Account;
class Group;

namespace UI
{
class AddressBookSelectorWidget;
}

}

/**
 * @author Duncan Mac-Vicar P. <duncan@kde.org>
 */
class AddContactWizard : public AddContactWizard_Base
{
	Q_OBJECT
  

public:
	AddContactWizard( TQWidget *parent = 0, const char *name = 0 );
	~AddContactWizard();
	virtual void showPage( TQWidget *page );

private:
	//Kopete::Protocol *currentProtocol;
	//AddContactPage *currentDataWidget;
	TQMap <Kopete::Account*,AddContactPage*> protocolPages;
	TQMap <TQCheckListItem*,Kopete::Account*> m_accountItems;
	TQMap <TQCheckListItem*,Kopete::Group*> m_groupItems;
	Kopete::UI::AddressBookSelectorWidget *m_addressbookSelectorWidget;

public slots:
	virtual void accept();
	virtual void reject();

	void slotProtocolListClicked( TQListViewItem * );

	void slotAddGroupClicked();

protected slots:
	virtual void next();
	void slotCheckAddresseeChoice( bool on );
	void slotAddresseeListClicked( TQListViewItem *addressee );
	void slotDataValid( AddContactPage *onPage, bool bOn);
};

#endif
