/*
    highlightconfig.h

    Copyright (c) 2003      by Olivier Goffart       <ogoffart @ kde.org>
    Copyright (c) 2003      by Matt Rogers           <matt@matt.rogers.name>

    Kopete    (c) 2002-2003 by the Kopete developers <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef HIGHLIGHTCONFIG_H
#define HIGHLIGHTCONFIG_H

#include <tqmap.h>
#include <tqstring.h>

class Filter;

class HighlightConfig
{
public:
	HighlightConfig();
	~HighlightConfig();

	void load();
	void save();

	TQPtrList<Filter> filters() const;
	void removeFilter (Filter *f);
	void appendFilter (Filter *f);
	Filter* newFilter();

private:
	TQPtrList<Filter> m_filters;
};

#endif
