//
// Copyright (C) 2003 Grzegorz Jaskiewicz <gj at pointblue.com.pl>
// Copyright (C) 2002-2003 Zack Rusin <zack@kde.org>
//
// gaduaddconectpage.h
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
// 02110-1301, USA.

#ifndef GADUADDCONTACTPAGE_H
#define GADUADDCONTACTPAGE_H

#include "addcontactpage.h"

class GaduAccount;
class GaduAddUI;
class TQLabel;
namespace Kopete { class MetaContact; }
class TQString;
class TQShowEvent;
class GaduAddUI;


class GaduAddContactPage : public AddContactPage
{
	Q_OBJECT
  

public:
	GaduAddContactPage( GaduAccount*, TQWidget* parent = 0, const char* name = 0 );
	~GaduAddContactPage();
	virtual bool validateData();
	virtual bool apply( Kopete::Account* , Kopete::MetaContact * );

	protected:
		void showEvent(TQShowEvent *e);

public slots:
	void  slotUinChanged( const TQString& );

private:
	void fillGroups();
	GaduAccount*	account_;
	GaduAddUI*	addUI_;
	TQLabel*		noaddMsg1_;
	TQLabel*		noaddMsg2_;
};

#endif
