/*
    Kopete Groupwise Protocol
    chatcountstask.cpp - Task to update chatroom participant counts

    Copyright (c) 2005      SUSE Linux Products GmbH	 http://www.suse.com

    Kopete (c) 2002-2005 by the Kopete developers <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This library is free software; you can redistribute it and/or         *
    * modify it under the terms of the GNU Lesser General Public            *
    * License as published by the Free Software Foundation; either          *
    * version 2 of the License, or (at your option) any later version.      *
    *                                                                       *
    *************************************************************************
*/

#ifndef CHATPROPERTIESTASK_H
#define CHATPROPERTIESTASK_H

#include <tqdatetime.h>
#include <tqvaluelist.h>
#include "gwchatrooms.h"
#include "gwerror.h"
#include "gwfield.h"

#include "requesttask.h"

/**
Get the current number of users in each chat on the server

@author SUSE Linux Products GmbH
 */
class ChatPropertiesTask : public RequestTask
{
	Q_OBJECT
  
	public:
		ChatPropertiesTask(Task* parent);
		~ChatPropertiesTask();
		/**
		 * Specify which chatroom to get properties for
		 */
		void setChat( const TQString & );
		bool take( Transfer * transfer );
		/**
		 * Contains a list of the ACL entries for the specified chatroom
		 */
		TQValueList< GroupWise::ChatContact > aclEntries();
		TQString m_chat;
		TQString m_ownerDn;
		TQString m_description;
		TQString m_disclaimer;
		TQString m_query;
		TQString m_archive;
		TQString m_maxUsers;
		TQString m_topic;
		TQString m_creatorDn;
		TQDateTime m_creationTime;
		uint m_rights;
		TQValueList< GroupWise::ChatContact > m_aclEntries;
};

#endif
