 /*
    icqaddcontactpage.h  -  ICQ Protocol Plugin

    Copyright (c) 2002 by Stefan Gehn <metz AT gehn.net>
    Copyright (c) 2004-2005 by Matt Rogers <mattr@kde.org>
    Kopete    (c) 2002-2005 by the Kopete developers  <kopete-devel@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/

#ifndef ICQADDCONTACTPAGE_H
#define ICQADDCONTACTPAGE_H

#include <tqwidget.h>
#include <addcontactpage.h>

/**
  *@author Matt Rogers
  *@author Stefan Gehn
  */
class icqAddUI;
class ICQAccount;
class ICQSearchDialog;

class ICQAddContactPage : public AddContactPage
{
Q_OBJECT
  

public:
	ICQAddContactPage(ICQAccount *owner, TQWidget *parent = 0, const char *name = 0);
	~ICQAddContactPage();
	
	virtual bool validateData();
	virtual bool apply(Kopete::Account* , Kopete::MetaContact *parentContact);
	
	void setUINFromSearch( const TQString& );
	
protected:
	void showEvent(TQShowEvent *e);
	
private slots:
	void showSearchDialog();
	void searchDialogDestroyed();
private:
	
	ICQAccount *mAccount;
	icqAddUI *addUI;
	ICQSearchDialog* m_searchDialog;
};

#endif
