
/*
 *
 *            kPPP: A front end for pppd for the KDE project
 *
 * $Id$
 *
 * Copyright (C) 1997 Bernd Johannes Wuebben
 * wuebben@math.cornell.edu
 *
 * based on EzPPP:
 * Copyright (C) 1997  Jay Painter
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *
 */


#ifndef _MODEMCMDS_H_
#define _MODEMCMDS_H_

#include <tqgroupbox.h>
#include <kdialogbase.h>
#include <tqlineedit.h>
#include <tqpushbutton.h>
#include <tqlabel.h>
#include <pppdata.h>

class TQLineEdit;
class TQLabel;
class TQPushButton;
class TQGroupBox;

class ModemCommands : public KDialogBase {

Q_OBJECT
  

public:

  ModemCommands(TQWidget *parent=0, const char *name=0);
  ~ModemCommands() {}

private slots:
  void slotCancel();
  void slotOk();

private:

  TQGroupBox *box;

  TQLineEdit *initstr[int(PPPData::NumInitStrings)];

  TQLineEdit *initresp;
  TQLabel *label2;

  TQSlider *preinitslider;
  TQLabel *lpreinitslider;
  TQLabel *lpreinit;

  TQSlider *initslider;
  TQLabel *linitslider;
  TQLabel *label3;

  TQSlider *durationslider;
  TQLabel *ldurationslider;
  TQLabel *lduration;

  TQLineEdit *nodetectdialtone;
  TQLabel *lnodetectdialtone;

  TQLineEdit *dialstr;
  TQLabel *label4;

  TQLineEdit *connectresp;
  TQLabel *label5;

  TQLineEdit *busyresp;
  TQLabel *label6;

  TQLineEdit *nocarrierresp;
  TQLabel *label7;

  TQLineEdit *nodialtoneresp;
  TQLabel *label8;

  TQLineEdit *hangupstr;
  TQLabel *label9;

  TQLineEdit *hangupresp;
  TQLabel *label10;

  TQLineEdit *answerstr;
  TQLabel *label11;

  TQLineEdit *ringresp;
  TQLabel *label12;

  TQLineEdit *answerresp;
  TQLabel *label13;

  TQLineEdit *escapestr;
  TQLabel *label14;

  TQLineEdit *escaperesp;
  TQLineEdit *dlpresp;
  TQLabel *label17;

  TQLabel *label15;

  TQSlider *slider;
  TQLabel *lslider;
  TQLabel *label16;

  TQLineEdit *volume_off, *volume_medium, *volume_high;
};
#endif



