//---------------------------------------------------------------------------
//
//             kPPP: A pppd front end for the KDE project
//
//---------------------------------------------------------------------------
//
// (c) 1997-1998 Bernd Johannes Wuebben <wuebben@kde.org>
// (c) 1997-1999 Mario Weilguni <mweilguni@kde.org>
// (c) 1998-1999 Harri Porten <porten@kde.org>
//
// derived from Jay Painters "ezppp"
//
//---------------------------------------------------------------------------
//
//  $Id$
//
//---------------------------------------------------------------------------
//
//  This program is free software; you can redistribute it and-or
//  modify it under the terms of the GNU Library General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Library General Public License for more details.
//
//  You should have received a copy of the GNU Library General Public
//  License along with this program; if not, write to the Free
//  Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
//
//---------------------------------------------------------------------------

#ifndef __MODEMDB__H__
#define __MODEMDB__H__

#include <tqdialog.h>
#include <tqstringlist.h>
#include <tqdict.h>
#include <tqptrlist.h>
class TDEConfig;
class TQListBox;

typedef TQDict<TQString> CharDict;

class ModemDatabase {
public:
  ModemDatabase();
  ~ModemDatabase();

  const TQStringList *vendors();
  TQStringList *models(TQString vendor);

  void save(TDEConfig *);

private:
  void load();
  void loadModem(const TQString & key, CharDict &dict);
  TQPtrList<CharDict> modems;

  TQStringList *lvendors;

  TDEConfig *modemDB;
};


class ModemSelector : public TQDialog {
  Q_OBJECT
  
public:
  ModemSelector(TQWidget *parent = 0);
  ~ModemSelector();

private slots:
  void vendorSelected(int idx);
  void modelSelected(int idx);
  void selected(int idx);

private:
  TQPushButton *ok, *cancel;
  TQListBox *vendor, *model;
  ModemDatabase *db;
};

#endif
