/*
 *            kPPP: A pppd front end for the KDE project
 *
 *
 *    
 *
 *            Copyright (C) 2004 Simone Gotti
 *               <simone.gotti@email.it>
 *
 * based on EzPPP:
 * Copyright (C) 1997  Jay Painter
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef _MODEMS_H_
#define _MODEMS_H_

#include <tqwidget.h>
#include <tqpushbutton.h>
#include <tqlistbox.h>
#include "acctselect.h"

class KDialogBase;
class TQCheckBox;
class TQLineEdit;
class TQTabDialog;
class DialWidget;
class ScriptWidget;
class IPWidget;
class DNSWidget;
class GatewayWidget;

class ModemsWidget : public TQWidget {
  Q_OBJECT
  
public:
  ModemsWidget( TQWidget *parent=0, const char *name=0 );
  ~ModemsWidget() {}

private slots:
  void editmodem();
  void copymodem();
  void newmodem();
  void deletemodem();
  void slotListBoxSelect(int);
  void modemNameChanged(const TQString &);

private:
  int doTab();

signals:
  void resetmodems();

private:
  TQString prettyPrintVolume(unsigned int);

  KDialogBase *tabWindow;
	ModemWidget *modem1;
  ModemWidget2 *modem2;
 /* DialWidget *dial_w;
  AccountingSelector *acct;
  IPWidget *ip_w;
  DNSWidget *dns_w;
  GatewayWidget *gateway_w;
  ScriptWidget *script_w;*/

  TQLabel *costlabel;
  TQLineEdit *costedit;
  TQLabel *vollabel;
  TQLineEdit *voledit;

  TQListBox *modemlist_l;
  TQPushButton *edit_b;
  TQPushButton *copy_b;
  TQPushButton *new_b;
  TQPushButton *delete_b;
};

#endif

