/***************************************************************************
                          main.h  -  controller object
                             -------------------
    begin                : Sat Jun 15 02:12:00 CET 2002
    copyright            : (C) 2002 by Tim Jansen
    email                : tim@tjansen.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAIN_H
#define MAIN_H

#include <tqobject.h>
#include "krdc.h"
#include "kremoteview.h"
#include "smartptr.h"

class TDEApplication;

class MainController : public TQObject {
	Q_OBJECT
  
private:
	SmartPtr<KRDC> m_krdc;
	WindowMode m_windowMode;
	TQString m_host, m_encodings, m_password, m_resolution;
	bool m_scale;
	bool m_localCursor;
	TQSize m_initialWindowSize;
	TQString m_keymap;
	Quality m_quality;

	TDEApplication *m_app;

public:
	MainController(TDEApplication *app, WindowMode wm,
		       const TQString &host,
		       Quality quality,
		       const TQString &encodings,
		       const TQString &password,
		       bool scale,
		       bool localCursor,
		       TQSize initialWindowSize);
	~MainController();
	int main();
	bool start();

private slots:
	void errorRestartRequested();
	void errorRestart();
};

#endif
